
/*
 *  Copyright (C) 2020-2021 Mayco S. Berghetti
 *
 *  This file is part of Netproc.
 *
 *  Netproc is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef M_TIME_H
#define M_TIME_H

#include <stdint.h>
#include <time.h>  // struct timespec

int
start_timer ( struct timespec *ts );

// return diff in milliseconds od old time and current time in milliseconds
uint64_t
diff_timer ( struct timespec *old_time );

// transform milliseconds in format hh:mm:ss
char *
sec2clock ( uint64_t milliseconds );

#endif  // MTIME_H
